Index: trunk/src/emx/src/emxbind/emxbind.c
===================================================================
--- trunk/src/emx/src/emxbind/emxbind.c	(revision 221)
+++ trunk/src/emx/src/emxbind/emxbind.c	(revision 222)
@@ -39,5 +39,5 @@
 /* The banner line of emxbind. */
 
-static char *title = "emxbind " VERSION " -- "
+static char *title = "emxbind " VERSION INNOTEK_VERSION " -- "
                      "Copyright (c) 1991-1997 by Eberhard Mattes";
 
Index: trunk/src/emx/src/emxbind/emxbind.h
===================================================================
--- trunk/src/emx/src/emxbind/emxbind.h	(revision 221)
+++ trunk/src/emx/src/emxbind/emxbind.h	(revision 222)
@@ -35,4 +35,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 /* Put this at the end of a function declaration to tell the compiler
Index: trunk/src/emx/src/emxcat/emxcat.c
===================================================================
--- trunk/src/emx/src/emxcat/emxcat.c	(revision 221)
+++ trunk/src/emx/src/emxcat/emxcat.c	(revision 222)
@@ -26,4 +26,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 #define NORETURN volatile
@@ -84,5 +85,5 @@
 static void NORETURN usage (void)
 {
-  fprintf (stderr, "emxcat " VERSION " -- "
+  fprintf (stderr, "emxcat " VERSION INNOTEK_VERSION " -- "
            "Copyright (c) 1992-1995 by Eberhard Mattes\n\n");
   fprintf (stderr, "Usage: emxcat [-D<symbol>]... -o <output_file> <input_file>...\n");
@@ -96,5 +97,5 @@
 {
   void *p;
-  
+
   p = malloc (n);
   if (p == NULL)
@@ -113,5 +114,5 @@
 {
   char *p;
-  
+
   p = xmalloc (strlen (s) + 1);
   strcpy (p, s);
@@ -305,5 +306,5 @@
 {
   edge *e;
-  
+
   v->mark = 1;
   v->number = vn++;
Index: trunk/src/emx/src/emxdoc/emxdoc.c
===================================================================
--- trunk/src/emx/src/emxdoc/emxdoc.c	(revision 221)
+++ trunk/src/emx/src/emxdoc/emxdoc.c	(revision 222)
@@ -40,4 +40,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 struct word_table
@@ -187,5 +188,5 @@
 static void usage (void)
 {
-  fputs ("emxdoc " VERSION " -- "
+  fputs ("emxdoc " VERSION INNOTEK_VERSION " -- "
          "Copyright (c) 1993-1999 by Eberhard Mattes\n\n", stderr);
   fputs ("Usage:\n", stderr);
Index: trunk/src/emx/src/emxexp/emxexp.c
===================================================================
--- trunk/src/emx/src/emxexp/emxexp.c	(revision 221)
+++ trunk/src/emx/src/emxexp/emxexp.c	(revision 222)
@@ -32,4 +32,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 struct bss_list
@@ -74,5 +75,5 @@
 {
   void *p;
-  
+
   p = malloc (n);
   if (p == NULL)
@@ -89,5 +90,5 @@
 {
   void *p;
-  
+
   p = realloc (ptr, n);
   if (p == NULL)
@@ -101,5 +102,5 @@
 static void usage (void)
 {
-  fputs ("emxexp " VERSION " -- Copyright (c) 1993-1995 by Eberhard Mattes\n\n"
+  fputs ("emxexp " VERSION INNOTEK_VERSION " -- Copyright (c) 1993-1995 by Eberhard Mattes\n\n"
          "Usage: emxexp [-n] [-u] [-o[<ordinal>] <input_file>...\n\n"
          "Options:\n"
Index: trunk/src/emx/src/emximp/emximp.c
===================================================================
--- trunk/src/emx/src/emximp/emximp.c	(revision 221)
+++ trunk/src/emx/src/emximp/emximp.c	(revision 222)
@@ -34,4 +34,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 #define NORETURN2 __attribute__ ((noreturn))
@@ -107,5 +108,5 @@
 static void usage (void)
 {
-  puts ("emximp " VERSION " -- Copyright (c) 1992-1996 by Eberhard Mattes\n");
+  puts ("emximp " VERSION INNOTEK_VERSION " -- Copyright (c) 1992-1996 by Eberhard Mattes\n");
   puts ("Usage:");
   puts ("  emximp [-a[<assembler>]] [-b <base_name>|<prefix_length>] "
Index: trunk/src/emx/src/emxload/emxload.c
===================================================================
--- trunk/src/emx/src/emxload/emxload.c	(revision 221)
+++ trunk/src/emx/src/emxload/emxload.c	(revision 222)
@@ -38,4 +38,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 /* ------------------------------ SERVER ------------------------------ */
@@ -319,5 +320,5 @@
   int i;
   time_t now, stop;
-  
+
   stop = 0;
 
@@ -750,5 +751,5 @@
 static void usage (void)
 {
-  fputs ("emxload " VERSION " -- "
+  fputs ("emxload " VERSION INNOTEK_VERSION " -- "
          "Copyright (c) 1993-1996 by Eberhard Mattes\n\n"
          "Usage: emxload [-m <limit>] [-s <limit>] [-e] [-u[w]]\n"
Index: trunk/src/emx/src/emxomf/emxaout.c
===================================================================
--- trunk/src/emx/src/emxomf/emxaout.c	(revision 221)
+++ trunk/src/emx/src/emxomf/emxaout.c	(revision 222)
@@ -46,4 +46,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 /* Insert private header files. */
@@ -211,5 +212,5 @@
 {
   void *p;
-  
+
   p = malloc (n);
   if (p == NULL && n != 0)
@@ -226,5 +227,5 @@
 {
   void *p;
-  
+
   p = realloc (ptr, n);
   if (p == NULL)
@@ -241,5 +242,5 @@
 {
   char *p;
-  
+
   p = xmalloc (strlen (s) + 1);
   strcpy (p, s);
@@ -267,5 +268,5 @@
 static void usage (void)
 {
-  puts ("emxaout " VERSION " -- Copyright (c) 1994-1996 by Eberhard Mattes\n");
+  puts ("emxaout " VERSION INNOTEK_VERSION " -- Copyright (c) 1994-1996 by Eberhard Mattes\n");
   puts ("Usage:");
   puts ("  emxaout [-u] [-o <output_file>] <input_file>");
@@ -705,5 +706,5 @@
    ³n   External name
    ³1-2 Type index
-   À 
+   À
 
    Symbol indices are assigned sequentially by EXTDEF and COMDEF. */
@@ -935,5 +936,5 @@
     F (bit 7)           1=frame thread, 0=methods F0 through F5
     Frame (bits 4-6)    frame thread number (F=1) or frame method (F=0)
-    T (bit 3)           1=target thread, 1=methods 
+    T (bit 3)           1=target thread, 1=methods
     P (bit 2)           Bit 2 of target method
     Targt (bits 0-1)    target thread number (T=1) or target method (T=0) */
Index: trunk/src/emx/src/emxomf/emxomf.c
===================================================================
--- trunk/src/emx/src/emxomf/emxomf.c	(revision 221)
+++ trunk/src/emx/src/emxomf/emxomf.c	(revision 222)
@@ -37,4 +37,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 /* Insert private header files. */
@@ -492,5 +493,5 @@
 {
   void *p;
-  
+
   p = malloc (n);
   if (p == NULL)
@@ -507,5 +508,5 @@
 {
   void *p;
-  
+
   p = realloc (ptr, n);
   if (p == NULL)
@@ -522,5 +523,5 @@
 {
   char *p;
-  
+
   p = xmalloc (strlen (s) + 1);
   strcpy (p, s);
@@ -548,5 +549,5 @@
   int i, j, n, len, t;
   const byte *s;
-  
+
   i = 4; len = strlen (name);
 
@@ -1508,5 +1509,5 @@
     F (bit 7)           1=frame thread, 0=methods F0 through F5
     Frame (bits 4-6)    frame thread number (F=1) or frame method (F=0)
-    T (bit 3)           1=target thread, 1=methods 
+    T (bit 3)           1=target thread, 1=methods
     P (bit 2)           Bit 2 of target method
     Targt (bits 0-1)    target thread number (T=1) or target method (T=0)  */
@@ -3148,5 +3149,5 @@
 static void usage (void)
 {
-  puts ("emxomf " VERSION " -- Copyright (c) 1992-1995 by Eberhard Mattes\n");
+  puts ("emxomf " VERSION INNOTEK_VERSION " -- Copyright (c) 1992-1995 by Eberhard Mattes\n");
   puts ("Usage:");
   puts ("  emxomf [-dgqs] [-l[<symbol>]] [-m <symbol>] [-p <page_size>]");
@@ -3398,5 +3399,5 @@
                 }
             }
-          
+
           /* Ignore the __.SYMDEF and __.IMPORT members.  Ignore
              import modules unless creating a library file. */
Index: trunk/src/emx/src/emxomf/emxomfar.c
===================================================================
--- trunk/src/emx/src/emxomf/emxomfar.c	(revision 221)
+++ trunk/src/emx/src/emxomf/emxomfar.c	(revision 222)
@@ -26,4 +26,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 typedef unsigned char byte;
@@ -61,5 +62,5 @@
 static void usage (void)
 {
-  fprintf (stderr, "emxomfar " VERSION " -- "
+  fprintf (stderr, "emxomfar " VERSION INNOTEK_VERSION " -- "
            "Copyright (c) 1992-1996 by Eberhard Mattes\n\n");
   fprintf (stderr, "Usage: emxomfar [-p#] <command> <library_file> [<module>]...\n");
Index: trunk/src/emx/src/emxomf/emxomfld.c
===================================================================
--- trunk/src/emx/src/emxomf/emxomfld.c	(revision 221)
+++ trunk/src/emx/src/emxomf/emxomfld.c	(revision 222)
@@ -37,4 +37,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 #define FALSE 0
@@ -157,5 +158,5 @@
 static void usage (void)
 {
-  fprintf (stderr, "emxomfld " VERSION " -- "
+  fprintf (stderr, "emxomfld " VERSION INNOTEK_VERSION " -- "
            "Copyright (c) 1992-1996 by Eberhard Mattes\n\n");
   fprintf (stderr,
Index: trunk/src/emx/src/emxomf/listomf.c
===================================================================
--- trunk/src/emx/src/emxomf/listomf.c	(revision 221)
+++ trunk/src/emx/src/emxomf/listomf.c	(revision 222)
@@ -30,4 +30,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 #pragma pack(1)
@@ -2338,5 +2339,5 @@
 static void usage (void)
 {
-  fputs ("listomf " VERSION " -- "
+  fputs ("listomf " VERSION INNOTEK_VERSION " -- "
          "Copyright (c) 1993-1996 by Eberhard Mattes\n\n"
          "Usage: listomf [-a] [-d] <input_file>\n\n"
Index: trunk/src/emx/src/emxstack/emxstack.c
===================================================================
--- trunk/src/emx/src/emxstack/emxstack.c	(revision 221)
+++ trunk/src/emx/src/emxstack/emxstack.c	(revision 222)
@@ -29,4 +29,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 /* How to open a file.  This type is used for my_open(). */
@@ -221,5 +222,5 @@
 static void usage (void)
 {
-  fputs ("emxstack " VERSION " -- "
+  fputs ("emxstack " VERSION INNOTEK_VERSION " -- "
          "Copyright (c) 1994-1995 by Eberhard Mattes\n\n", stderr);
   fputs ("Usage: emxstack <command> [<options>] <file>...\n", stderr);
@@ -552,5 +553,5 @@
   new_stack_size = ROUND_PAGE (n * 1024);
 }
-  
+
 
 /* The main function of emxstack. */
Index: trunk/src/emx/src/emxtsf/emxtsf.c
===================================================================
--- trunk/src/emx/src/emxtsf/emxtsf.c	(revision 221)
+++ trunk/src/emx/src/emxtsf/emxtsf.c	(revision 222)
@@ -30,4 +30,5 @@
 
 #define VERSION "0.9d"
+#include "../../../../include/innotekversion.h"
 
 
@@ -61,5 +62,5 @@
 static void usage (void)
 {
-  fputs ("emxtsf " VERSION " -- Copyright (c) 1996 by Eberhard Mattes\n\n"
+  fputs ("emxtsf " VERSION INNOTEK_VERSION " -- Copyright (c) 1996 by Eberhard Mattes\n\n"
          "Usage: emxtsf [-d <dll_name>] [-w <level>] <tss_file> <map_file> <def_file>\n",
          stderr);