Index: /trunk/openjdk/jdk/make/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/Makefile	(revision 231)
+++ /trunk/openjdk/jdk/make/Makefile	(revision 232)
@@ -262,6 +262,6 @@
 ifndef OS2_TEMP
 SUBDIRS    = tools java javax org sun sunw com jpda mkdemo mksample launchers
-else # disable various stuff
-SUBDIRS    = tools java javax org sun sunw com launchers
+else # disable JPDA
+SUBDIRS    = tools java javax org sun sunw com mkdemo mksample launchers
 endif
 all build::
Index: /trunk/openjdk/jdk/make/common/Demo.gmk
===================================================================
--- /trunk/openjdk/jdk/make/common/Demo.gmk	(revision 231)
+++ /trunk/openjdk/jdk/make/common/Demo.gmk	(revision 232)
@@ -28,4 +28,5 @@
 # Some names are defined with LIBRARY inside the Defs.gmk file
 LIBRARY=$(DEMONAME)
+LIBRARY_SHORT=$(DEMONAME_SHORT)
 OBJDIR=$(TEMPDIR)/$(DEMONAME)
 
@@ -123,6 +124,11 @@
 ifneq ($(strip $(DEMO_ALL_NATIVE_SOURCES)),)
   # Path to native library we will create
-  DEMO_LIBRARY = \
-      $(DEMO_DESTDIR)/lib$(ISA_DIR)/$(LIB_PREFIX)$(DEMONAME).$(LIBRARY_SUFFIX)
+  ifneq ($(DEMONAME_SHORT),)
+    DEMO_LIBRARY = \
+        $(DEMO_DESTDIR)/lib$(ISA_DIR)/$(LIB_PREFIX)$(DEMONAME_SHORT).$(LIBRARY_SUFFIX)
+  else
+    DEMO_LIBRARY = \
+        $(DEMO_DESTDIR)/lib$(ISA_DIR)/$(LIB_PREFIX)$(DEMONAME).$(LIBRARY_SUFFIX)
+  endif
   # C and C++ compiler flags we need to add to standard flags
   DEMO_CPPFLAGS     += -I$(DEMO_BUILD_SRCDIR)
Index: /trunk/openjdk/jdk/make/mkdemo/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/mkdemo/Makefile	(revision 231)
+++ /trunk/openjdk/jdk/make/mkdemo/Makefile	(revision 232)
@@ -32,5 +32,9 @@
 include $(BUILDDIR)/common/Defs.gmk
 
+ifndef OS2_TEMP
 SUBDIRS = applets jfc jvmti management jni scripting jpda
+else # disable JPDA
+SUBDIRS = applets jfc jvmti management jni scripting
+endif
 
 all build:: nbproject
Index: /trunk/openjdk/jdk/make/mkdemo/jvmti/compiledMethodLoad/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/mkdemo/jvmti/compiledMethodLoad/Makefile	(revision 231)
+++ /trunk/openjdk/jdk/make/mkdemo/jvmti/compiledMethodLoad/Makefile	(revision 232)
@@ -27,4 +27,5 @@
 PRODUCT = demo/jvmti
 DEMONAME = compiledMethodLoad
+DEMONAME_SHORT = cml
 include $(BUILDDIR)/common/Defs.gmk
 
Index: /trunk/openjdk/jdk/make/mkdemo/jvmti/heapTracker/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/mkdemo/jvmti/heapTracker/Makefile	(revision 231)
+++ /trunk/openjdk/jdk/make/mkdemo/jvmti/heapTracker/Makefile	(revision 232)
@@ -27,4 +27,5 @@
 PRODUCT = demo/jvmti
 DEMONAME = heapTracker
+DEMONAME_SHORT = heapTrck
 include $(BUILDDIR)/common/Defs.gmk
 
Index: /trunk/openjdk/jdk/make/mkdemo/jvmti/heapViewer/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/mkdemo/jvmti/heapViewer/Makefile	(revision 231)
+++ /trunk/openjdk/jdk/make/mkdemo/jvmti/heapViewer/Makefile	(revision 232)
@@ -27,4 +27,5 @@
 PRODUCT = demo/jvmti
 DEMONAME = heapViewer
+DEMONAME_SHORT = heapView
 include $(BUILDDIR)/common/Defs.gmk
 
Index: /trunk/openjdk/jdk/make/mkdemo/jvmti/hprof/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/mkdemo/jvmti/hprof/Makefile	(revision 231)
+++ /trunk/openjdk/jdk/make/mkdemo/jvmti/hprof/Makefile	(revision 232)
@@ -36,6 +36,9 @@
 DEMO_OBJECTS    = java_crw_demo.$(OBJECT_SUFFIX)
 
-ifeq ($(filter-out windows os2, $(PLATFORM)),)
+ifeq ($(PLATFORM), windows)
   EXTRA_LIBS += wsock32.lib winmm.lib
+endif
+ifeq ($(PLATFORM), os2)
+  EXTRA_LIBS += -lwsock32.lib -lwinmm.lib
 endif
 ifeq ($(PLATFORM), solaris)
Index: /trunk/openjdk/jdk/make/mkdemo/jvmti/versionCheck/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/mkdemo/jvmti/versionCheck/Makefile	(revision 231)
+++ /trunk/openjdk/jdk/make/mkdemo/jvmti/versionCheck/Makefile	(revision 232)
@@ -27,4 +27,5 @@
 PRODUCT = demo/jvmti
 DEMONAME = versionCheck
+DEMONAME_SHORT = verCheck
 include $(BUILDDIR)/common/Defs.gmk
 